#include <WiFi.h>
#include <PubSubClient.h>

#define WIFISSID "Vodafone_ADSL_" // Put your WifiSSID here
#define PASSWORD "EVER101024093622" // Put your wifi password here
#define TOKEN "A1E-cCuErTjvGp2iKNbAE1RVxtt2BWZPvc" // Put your Ubidots' TOKEN
#define MQTT_CLIENT_NAME "Hamada987Katamesh" // MQTT client Name, please enter your own 8-12 alphanumeric character ASCII string; 
                                           //it should be a random and unique ascii string and different from all other devices

/****************************************
 * Define Constants
 ****************************************/
const char * VARIABLE_LABEL_1 = "distance"; // Assing the variable label
const char * VARIABLE_LABEL_2 = "humidity"; // Assign the variable label
const char * VARIABLE_LABEL_3 = "temperature";
const char * DEVICE_LABEL = "esp32"; // Assig the device label

 // Set the GPIO12 as SENSOR

char mqttBroker[]  = "things.ubidots.com";
char payload[300];
char topic[150];
// Space to store values to send
char str_sensor[10];
char str_TempSensor[10];
char str_HumSensor[10];

/****************************************
 * Auxiliar Functions
 ****************************************/
WiFiClient ubidots;
PubSubClient client(ubidots);

void callback(char* topic, byte* payload, unsigned int length) {
  char p[length + 1];
  memcpy(p, payload, length);
  p[length] = NULL;
  String message(p);
  Serial.write(payload, length);
  Serial.println(topic);
}

void reconnect() {
  // Loop until we're reconnected
  while (!client.connected()) {
    Serial.println("Attempting MQTT connection...");
    
    // Attemp to connect
    if (client.connect(MQTT_CLIENT_NAME, TOKEN, "")) {
      Serial.println("Connected");
    } else {
      Serial.print("Failed, rc=");
      Serial.print(client.state());
      Serial.println(" try again in 2 seconds");
      // Wait 2 seconds before retrying
      delay(2000);
    }
  }
}

/****************************************
 * Main Functions
 ****************************************/
void setup() {
  Serial.begin(115200);
  WiFi.begin(WIFISSID, PASSWORD);
  // Assign the pin as INPUT 
  

  Serial.println();
  Serial.print("Wait for WiFi...");
  
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    delay(500);
  }
  
  Serial.println("");
  Serial.println("WiFi Connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  client.setServer(mqttBroker, 1883);
  client.setCallback(callback);  
}

void loop() {
  if (!client.connected()) {
    reconnect();
  }
 float distance=random(0,100);
 float humidity=random(20,200);
 float temperature=random(150,300);

  dtostrf(distance, 4, 2, str_sensor);
  dtostrf(humidity, 4, 2, str_HumSensor);
  dtostrf(temperature, 4, 2, str_TempSensor);
  
  
  sprintf(topic, "%s%s", "/v1.6/devices/", DEVICE_LABEL);
  sprintf(payload, "%s", ""); // Cleans the payload
  sprintf(payload, "{\"%s\": %s,", VARIABLE_LABEL_1, str_sensor); // Adds the variable label
  sprintf(payload, "%s\"%s\": %s,", payload, VARIABLE_LABEL_2, str_HumSensor); // Adds the variable label
  sprintf(payload, "%s\"%s\": %s}", payload, VARIABLE_LABEL_3, str_TempSensor); 
  
 
  
  /* 4 is mininum width, 2 is precision; float value is copied onto str_sensor*/
 
  
  sprintf(payload, "%s {\"value\": %s}}", payload, str_sensor); // Adds the value
  Serial.println("Publishing data to Ubidots Cloud");
  Serial.print("Distance = ");
  Serial.println(distance);
  Serial.print("Humidity = ");
  Serial.println(humidity);
  Serial.print("Temperature = ");
  Serial.println(temperature);
  Serial.println("payload");
  Serial.println(payload);
  client.publish(topic, payload);
  client.loop();
  delay(1000);
}
